//+------------------------------------------------------------------+
//|                                              GlobalVariables.mq5 |
//|                                           Copyright 2015, MigVRN |
//|                                                    Miguzov@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MigVRN"
#property link      "Miguzov@bk.ru"
#property version   "1.00"

#include <My_struct.mqh>
#include <Interchange.mqh>

Indicator_data Exp_Data;         //  -  
CInterchange Exp_buffer;         //    

int handle_GUI;                  //  - 
int count_timer;                 //  -     
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---  -     
   MqlParam Param_GUI[1];
   Param_GUI[0].type=TYPE_STRING;
   Param_GUI[0].string_value="Test_Glob_Var";
   handle_GUI=IndicatorCreate(_Symbol,_Period,IND_CUSTOM,1,Param_GUI);
   ChartIndicatorAdd(0,1,handle_GUI);

//---   -  
   count_timer=0;
   CopyInfo(count_timer);

//---     
   Exp_buffer.StartSendData(Exp_Data);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---   
   Exp_buffer.Destroy();
   ChartIndicatorDelete(0,1,"Test("+_Symbol+")");
   IndicatorRelease(handle_GUI);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---    
   Exp_buffer.OnEvent(id,lparam,dparam,sparam);

//---  ,      
   if(id==CHARTEVENT_CUSTOM+2015)
     {
      //---   -  
      count_timer++;
      CopyInfo(count_timer);
      //---   
      Exp_buffer.StartSendData(Exp_Data);
     }

   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| ,                              |
//+------------------------------------------------------------------+ 
void CopyInfo(int b)
  {
//double summ=0; //  
   for(int i=0; i<SIZE_BUFFER_INDICATOR; i++)
     {
      Exp_Data.AverageBuffer[i]=MathSin((i+b)*M_PI/60.0);
      Exp_Data.HighPriceBuffer[i]= MathSin((i+b)*M_PI/40.0);
      Exp_Data.LowPriceBuffer[i] = MathSin((i+b)*M_PI/20.0);
      Exp_Data.AverageColors[i]=char(2*MathRand()/32767);
      Exp_Data.LowPriceColors[i]=char(2*MathRand()/32767);
      Exp_Data.HighPriceColors[i]=char(2*MathRand()/32767);

/*summ+=Exp_Data.AverageBuffer[i]+
            Exp_Data.HighPriceBuffer[i] +
            Exp_Data.LowPriceBuffer[i] +
            Exp_Data.AverageColors[i] +
            Exp_Data.LowPriceColors[i] +
            Exp_Data.HighPriceColors[i];*/
     }
//Print(summ); 
  }
//+------------------------------------------------------------------+
